#!/bin/bash
# set -x
# shopt -s nullglob #use wildcards
scriptdir=`dirname $0`
if (( $# < 1 )); then 
	echo "Usage:"
	echo "$0 n"
	echo ">> looks for data ( ${scriptdir}/block-{n}/02-inspect/ecolux-data-*-filtered )"
	echo ">> prints info about tags and detections"
	echo ""
	echo "$0 n list"
	echo ">> looks for file like above"
	echo ">> write list of unknown tags together with their occurrences to file unknowntags-block-{n}"
	exit
fi

# filename_suffix=`basename "$1" | cut -d'-' -f5-`
# if [ "$filename_suffix" == "" ]; then
# 	#before
# 	COL_TAG=9 
# 	HEADER_SIZE=`grep -c "#" "$1"`
# else
	#after col-insertions from dataFilter.py
COL_TAG=12 
HEADER_SIZE=1
# fi

in=`ls ${scriptdir}/block-${1}/02-inspect/ecolux-data-*-filtered | head -1`
LEN_W_HEADER=`wc -l "$in" | cut -d" " -f1`
LEN=$(( $LEN_W_HEADER - $HEADER_SIZE))

function unknownTags() {

	unknown=`tail -${LEN} "$in"| cut -d',' -f"$COL_TAG"- "$in" | grep "NA" | cut -d',' -f1 | sort | uniq`
	for tag in $unknown; do
		echo $tag
		n=`grep -c "$tag" $2`
		echo "$n : $tag" >> tmp
	done

	sort -r -t : -k 1 -g tmp > "unknown-tags-block-${1}"
	rm tmp
}

function info() {

	SCALE=2 #floating-point precision

	echo "## Tags"
	tag_total=`tail -${LEN} "$in" | cut -d',' -f"$COL_TAG" | sort | uniq | wc -l`
	tag_known=`tail -${LEN} "$in" | cut -d',' -f"$COL_TAG"- | grep -v "NA" | cut -d',' -f1 | sort | uniq | wc -l`
	tag_unknown=`tail -${LEN} "$in" | cut -d',' -f"$COL_TAG"- | grep "NA" | cut -d',' -f1 | sort | uniq | wc -l`

	tag_known_percent=$(bc <<< "scale=$SCALE; $tag_known * 100 /$tag_total")
	tag_unknown_percent=$(bc <<< "scale=$SCALE; $tag_unknown * 100 / $tag_total" )

	echo "  total: $tag_total"
	echo "  known: $tag_known 	(${tag_known_percent}%)"
	echo "unknown: $tag_unknown 	(${tag_unknown_percent}%)"
	echo ""

	echo "## Detections"
	detection_known=`tail -${LEN} "$in" | cut -d',' -f"$COL_TAG"- | grep -v "NA" | cut -d',' -f1 | wc -l`
	detection_unknown=`tail -${LEN} "$in" | cut -d',' -f"$COL_TAG"- | grep "NA" | cut -d',' -f1 | wc -l`
	detection_known_percent=$(bc <<< "scale=$SCALE; $detection_known * 100 / $LEN"  )
	detection_unknown_percent=$(bc <<< "scale=$SCALE; $detection_unknown * 100 / $LEN"  )

	echo "  total: $LEN"
	echo "  known: $detection_known 	(${detection_known_percent}%)"
	echo "unknown: $detection_unknown	(${detection_unknown_percent}%)"
}


if (( $# == 1 )); then
	info "$in"
else
	unknownTags "$1" "$in"
fi